﻿using Newtonsoft.Json;
using Newtonsoft.Json.Bson;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;


namespace BonsSampleClient
{
    class Program
    {
        static void Main(string[] args)
        {
            var client = new HttpClient();
            client.DefaultRequestHeaders.Accept.Add(new MediaTypeWithQualityHeaderValue("application/bson"));
            Task<Stream> stream = client.GetStreamAsync("http://localhost:30686/api/values");

            MemoryStream result = new MemoryStream();
            stream.Result.CopyTo(result);
            result.Seek(0, SeekOrigin.Begin);

            using (BsonReader reader = new BsonReader(result) { ReadRootValueAsArray = true })
            {
                var jsonSerializer = new JsonSerializer();
                var output = jsonSerializer.Deserialize<IEnumerable<string>>(reader);
                foreach (var item in output)
                {
                    Console.WriteLine(item);
                }
            }
        }
    }
}
